
from OFS.Folder import Folder
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Globals import InitializeClass
import os.path
import App.Common

# --
# Product registration and Add support
# --

def manage_addJsonExamples(self, id, REQUEST=None):
    'Add jsonserver examples.'
    id = str(id)
    id = self._setObject(id, Folder(id))
    folder = self._getOb(id)
    # create the contents
    examples = os.path.join(App.Common.package_home(globals()), 'examples')
    
    addPt = folder.manage_addProduct['PageTemplates'].manage_addPageTemplate
    addFile = folder.manage_addProduct['OFSP'].manage_addFile
    addPs = folder.manage_addProduct['PythonScripts'].manage_addPythonScript
    addRst = folder.manage_addProduct['ZReST'].manage_addZReST

    def readfile(name):
        return file(os.path.join(examples, name)).read()

    for name in ('readme', ):
        addRst(name, file=readfile(name))
        
    for name in ('json_1', 'json_2', 'json_3', 'json_4', 'my_portlet'):
        addPt(name, text=readfile(name))
        
    for name in ('delayed_output', 'my_data', 'my_output', 'index_html', 'uni_data'):
        addPs(name)
        ps = folder._getOb(name)
        ps.write(readfile(name))

    for name in ('default.css', ):
        addFile(name, file=readfile(name))
        
    # finish
    if REQUEST is not None:
        try:
            url = self.DestinationURL()
        except: 
            url = REQUEST['URL1']
        REQUEST.RESPONSE.redirect('%s/manage_main' % url)
    return ''

def initialize(context):
    manage_addJsonExamplesForm = PageTemplateFile('www/jsonexamplesAdd', globals())
    context.registerClass(
        None,
        meta_type='Jsonserver examples',
        constructors=(manage_addJsonExamplesForm, manage_addJsonExamples),
        )

